# <PRE>
# Copyright for the Uniform Repository Service (c) 1995 - 2014,
# by Gerald Banon. All rights reserved.
# Version 2.1
# Script

# Administrator Page for setting field value attributes

# this script is in the repository: iconet.com.br/banon/2007/01.01.16.00
# to run this script enter the following web address in your browser:

if 0 {
http://banon-pc.dpi.inpe.br:1905/col/iconet.com.br/banon/2007/01.01.16.00/doc/script.cgi?
}

# ----------------------------------------------------------------------
# Script

proc Script {} {
if [catch {
	set currentProcedureName Script	;# used in displayControl.tcl among other uses

	global env
	global cgi	;# used by FindLanguage and DisplayMultipleSearch
	global homePath	;# used by CreateAnnualTable, SynchronizeRepository, LoadService and FindLanguage
	global thisRepository ;# used by SetData
	global currentRep ;# used by DisplayMultipleSearch
	global language ;# used by DisplayMultipleSearch
	global numberOfActiveSites numberOfSites
	global serverAddress	;# used in SetFieldValue
	global serverAddressWithIP	;# used in DisplayMultipleSearch
	global multipleLineReferFieldNamePattern	;# used by GetReferField (called by CreateVersionStamp (called by ChangeFieldValue))
	global localSite	;# used by SynchronizeRepository (sourceDisplayControl)
	global loCoInRep	;# used by SynchronizeRepository (sourceDisplayControl)
	global loBiMiRep	;# used while executing SynchronizeRepository (sourceDisplayControl)
	global URLibServiceRepository	;# used while executing SynchronizeRepository (sourceDisplayControl)

	puts {Content-Type: text/html}
	puts {}

	set col ../../../../..
	set englishMirrorRepository dpi.inpe.br/banon/1999/05.03.22.11
# URLibServiceRepository
	set URLibServiceRepository $env(URLIB_SERVICE_REP)
	set pwd [pwd]

# homePath
	set homePath $env(DOCUMENT_ROOT)	;# used by LoadService and SetData
# serverAddress
	set serverAddress [list $env(SERVER_NAME) $env(URLIB_PORT)]	;# used in SetFieldValue
# serverAddressWithIP
	set serverAddressWithIP [list $env(IP_ADDR) $env(URLIB_PORT)]	;# used in CheckUsernamePasswordForm
# localSite
# used in xxAdministratorPage.html 
	set localSite $env(SERVER_NAME):$env(SERVER_PORT)	;# $env(HTTP_HOST) not used because can be shorter like sputnik:1909
# loCoInRep
	set loCoInRep $env(LOCOINREP)
# loBiMiRep
	set loBiMiRep $env(LOBIMIREP)
# multipleLineReferFieldNamePattern
# used by GetReferField (called by CreateVersionStamp (called by ChangeFieldValue))
	set multipleLineReferFieldNamePattern $env(MULI_PATTERN)

# http
	set http http[expr [info exists env(HTTPS)]?{s}:{}]

# thisRepository
	regexp {^.*/col/(.*)/auxdoc/cgi} $pwd m thisRepository

	source ../$col/$URLibServiceRepository/doc/utilitiesStart.tcl	;# ListNegatedImplication
	source ../$col/$URLibServiceRepository/doc/utilities1.tcl
	source ../$col/$URLibServiceRepository/doc/utilities3.tcl
	source ../$col/$URLibServiceRepository/doc/cgi/mirrorfind-.tcl
	source ../$col/$URLibServiceRepository/doc/accentTables.tcl	;# set accentTable used in CreateFieldValueRangeArray

# Capture URL
	if {[info exists env(QUERY_STRING)] && [string compare {} $env(QUERY_STRING)] != 0} {
# GET style
		set query $env(QUERY_STRING)
# puts $query
		foreach {name value} [split $query &=] {
			set cgi([DecodeURL $name]) [DecodeURL $value]
		}
	}
# Capture URL - end
	CreateCGIArray 1
# puts [array names cgi]

# year
	set year $cgi(year)	;# 2007
	if [string equal {} $year] {
		puts "Script: year is emtpy"
		return
	}
# publishingYear - used in displayControl.tcl
	set publishingYear $year
# mappingDomainName
	set mappingDomainName $cgi(fieldname)	;# journal
	if [string equal {} $mappingDomainName] {
		puts "Script: field name is emtpy."
		return
	}
	
	set referenceTypeListForArray {
		journal {Journal Article}
		conferencename {Conference Proceedings}
	}
	array set referenceTypeArray $referenceTypeListForArray
# referenceType
	set referenceType $referenceTypeArray($mappingDomainName)

	CreateFieldValueRangeArray $mappingDomainName, A a h
	CreateFieldValueRangeArray $mappingDomainName, A i o
	CreateFieldValueRangeArray $mappingDomainName, A p r
	CreateFieldValueRangeArray $mappingDomainName, A s z
	CreateFieldValueRangeArray $mappingDomainName, B a o
	CreateFieldValueRangeArray $mappingDomainName, B p z
	CreateFieldValueRangeArray $mappingDomainName, C a h
	CreateFieldValueRangeArray $mappingDomainName, C i l
	CreateFieldValueRangeArray $mappingDomainName, C m z
	CreateFieldValueRangeArray $mappingDomainName, D
	CreateFieldValueRangeArray $mappingDomainName, E a n
	CreateFieldValueRangeArray $mappingDomainName, E o z
	CreateFieldValueRangeArray $mappingDomainName, F
	CreateFieldValueRangeArray $mappingDomainName, G a e
	CreateFieldValueRangeArray $mappingDomainName, G f z
	CreateFieldValueRangeArray $mappingDomainName, H
	CreateFieldValueRangeArray $mappingDomainName, I
	CreateFieldValueRangeArray $mappingDomainName, J a l
	CreateFieldValueRangeArray $mappingDomainName, J m z
	CreateFieldValueRangeArray $mappingDomainName, {K L}
	CreateFieldValueRangeArray $mappingDomainName, M a e
	CreateFieldValueRangeArray $mappingDomainName, M f z
	CreateFieldValueRangeArray $mappingDomainName, {N O}
	CreateFieldValueRangeArray $mappingDomainName, P a e
	CreateFieldValueRangeArray $mappingDomainName, P f k
	CreateFieldValueRangeArray $mappingDomainName, P l z
	CreateFieldValueRangeArray $mappingDomainName, Q
	CreateFieldValueRangeArray $mappingDomainName, R a d
	CreateFieldValueRangeArray $mappingDomainName, R e e
	CreateFieldValueRangeArray $mappingDomainName, R f z
	CreateFieldValueRangeArray $mappingDomainName, S a l
	CreateFieldValueRangeArray $mappingDomainName, S m z
	CreateFieldValueRangeArray $mappingDomainName, T a l
	CreateFieldValueRangeArray $mappingDomainName, T m z
	CreateFieldValueRangeArray $mappingDomainName, {U Z}

# fieldValueRange
	set fieldValueRange $cgi(fieldvaluerange)	;# Aa-Ai
# fieldValueRange2
	if [string equal {} $fieldValueRange] {
		set fieldValueRange2 {}
	} else {
		set fieldValueRange2 $fieldValueRangeArray($fieldValueRange)
	}

# searchDomain
	set searchDomain $cgi(searchdomain)	;# ar SRE
# secondarySearch
	set secondarySearch $cgi(secondarysearch)	;# index 0
# mirrorRep
	set mirrorRep $cgi(mirror)
# puts $mirrorRep
	if [string equal {} $mirrorRep] {
		puts "Script: mirror is emtpy."
		return
	}
	set currentRep $mirrorRep ;# used in error message (unknown username)
# siteList
	if [file exists $homePath/col/$thisRepository/auxdoc/@siteList.tcl] {
		source $homePath/col/$thisRepository/auxdoc/@siteList.tcl	;# set siteList
	} else {
		set siteList [ComputeSiteList $mirrorRep]
	}

# Find the language and the language repository
# needed for the button images
	foreach {language languageRep1 languageRep2 firstLanguageRep \
	submissionFormRep submissionFormLanguage submissionFormLanguageRep} \
	[FindLanguage $mirrorRep] {break}
# Find the language and the language repository - end

# puts [list $language $languageRep1 $submissionFormRep]

	if [file exists ../../doc/${language}AdministratorPage.html] {
		Load ../../doc/${language}AdministratorPage.html fileContent
	} else {
# default
		Load ../../doc/enAdministratorPage.html fileContent
	}

# userName
# used in xxAdministratorPage.html
#	LoadService $thisRepository userName userName 1 1	;# doesn't work when using a copy
	LoadService $thisRepository authenticatedUsers authenticatedUsers 0 1
	set userName [lindex $authenticatedUsers 0]	;# take the first
	if [string equal {} $userName] {
		puts "Script: read user not defined."
		return
	}

# mirrorHomePageRepository
# used in sourceDisplayControl (actually, the content of displayControl.tcl in this repository is used as default)
	set mirrorHomePageRepository dpi.inpe.br/banon/2000/01.23.20.24

	if {![info exists cgi(run)] || !$cgi(run)} {
# >>> first step (invoke)

		StoreArray cgi $homePath/col/$thisRepository/auxdoc/cgiArray.tcl w list array 1
		
# puts [info patch]
 
# Source displayControl.tcl
		set enableOutput 1
		eval $sourceDisplayControl	;# set displayTable and boxTable used in ReturnAttributeValue
# Source displayControl.tcl - end
# puts --[array names attributeListTable]--

		if ![info exists attributeListTable] {
			puts "Script: attributeListTable doesn't exists for the year $year in the current displayControl.tcl."
			return
		}

# Source controlArray.tcl
		if [file exists $homePath/col/$thisRepository/auxdoc/controlArray.tcl] {
			source $homePath/col/$thisRepository/auxdoc/controlArray.tcl
		}
# Source controlArray.tcl - end

# attributeList (attributeListTable is set in displayControl.tcl)
# example:
# set attributeListTable(year=2011,journal) {dissemination issn secondarytype}
# puts --[array get attributeListTable]--
		ConditionalSet attributeList attributeListTable(year=$year,$mappingDomainName) {}
# puts --$attributeList--

# Update controlArray.tcl with a new year
		if {[llength [array names controlArray attributeTable(year=$year*)]] == 0} {
# new year - add the data of the new year by copying the data of the previous one (if it exists)
			set previousYear [expr $year - 1]
			set inputList [array names controlArray attributeTable(year=$previousYear*)]
			foreach input $inputList {
				regsub "year=$previousYear" $input "year=$year" input2
				set controlArray($input2) $controlArray($input)
			}
			StoreArray controlArray $homePath/col/$thisRepository/auxdoc/controlArray.tcl w list array 1
# Create year=XXXX_mappingDomainName_attributeName.tcl
			CreateAnnualTable $thisRepository $attributeList $year $mappingDomainName
# Create year=XXXX_mappingDomainName_attributeName.tcl - end
		}
# Update controlArray.tc with a new year - end

# array set attributeTable
		foreach index [array names controlArray] {
			set $index $controlArray($index)	;# set attributeTable
		}
	
#		upvar 0 controlArray cgi	;# <<<

#		if ![info exists cgi(codedpassword1)] {set cgi(codedpassword1) {}}

# seconds
# used in xxAdministratorPage.html 
		set seconds "<INPUT TYPE=HIDDEN NAME=\"seconds\" VALUE=\"[clock seconds]\">"

# sessionTime
# symmetricKey
		foreach {sessionTime symmetricKey} [OpenSession [list $env(REMOTE_ADDR) administrator] symmetricKey] {break}

# Used by JavaScript
		set wrongPassword {no}
# Used by JavaScript - end

	} else {
# >>> second step (perform)
# PROCESS

		if [file exists ../../doc/${language}AdministratorPage.html] {
			source ../$col/$languageRep2/doc/mirror/${language}Submit.tcl
		} else {
			source ../$col/$englishMirrorRepository/doc/mirror/enSubmit.tcl
			set languageRep1 dpi.inpe.br/banon/1999/05.03.22.11
			set languageRep2 dpi.inpe.br/banon/1999/05.03.22.11
		}

		global "${languageRep2}::Please wait for the submission completion."
		global "${languageRep2}::update header"
		global "${languageRep2}::empty password"
		global "${languageRep2}::wrong password"
		global "${languageRep2}::unknown username"
		global "${languageRep2}::Continue"
		global "${languageRep2}::footer"
		global "${languageRep2}::currentVariableFileName"	;# for reverse engineering

		set header ${update header}	;# needed in error message (unknown username)

		set submissionType {}	;# used in ${wrong password}
# check the form
		set cellFont {<FONT FACE="Courier New" SIZE=2>}	;# used in ${wrong password}
# Similar to Submit
		set returnButton "
<HR><TABLE ALIGN=CENTER><TR><TD>
<FORM NAME=error METHOD=POST ACTION=\"$http://$localSite/col/$thisRepository/doc/script.cgi\">
"
# passworderror value must be 1
		CreateHiddenInput returnButton
		append returnButton "\
<INPUT TYPE=HIDDEN NAME=passworderror VALUE=1>
<INPUT TYPE=submit VALUE=$Continue class=submitButton>
</FORM></TD></TR></TABLE>
"

#		if ![info exists cgi(codedpassword1)] {set cgi(codedpassword1) {}}	;# used in CheckUsernamePasswordForm
		set message [subst [subst [CheckUsernamePasswordForm]]]	;# sets password1 - uses cgi array
		if ![string equal {} $message] {
# regsub is useful for unknown username and wrong password
			regsub {NAME="wrongpassword" VALUE="no"} $message {NAME="wrongpassword" VALUE="yes"} message
			regsub {NAME="run" VALUE="1"} $message {NAME="run" VALUE="0"} message
			puts $message
			return
		}
# Similar to Submit - end
# check the form - end
# OK

#		upvar 0 cgi controlArray	;# <<<

# Source controlArray.tcl
		if [file exists $homePath/col/$thisRepository/auxdoc/controlArray.tcl] {
			source $homePath/col/$thisRepository/auxdoc/controlArray.tcl
		}
# Source controlArray.tcl - end

		set attributeList $cgi(attributelist)

# update controlArray
		foreach index [array names cgi item:*] {
			regsub {item:} $index {} item
			regsub {^_} $item {} item3	;# _Acta -> Acta - added by GJFB in 2014-07-07 (now item begins with _)
			foreach attributeName $attributeList {
#				set name attributeTable(year=$cgi(year),$cgi(fieldname),$attributeName,$item)
				set name attributeTable(year=$cgi(year),$cgi(fieldname),$attributeName,$item3)	;# added by GJFB in 2014-07-07
				if {![info exists cgi($name)] || \
				[string equal {} $cgi($name)]} {
					if [info exists controlArray($name)] {unset controlArray($name)}
				} else {
					set controlArray($name) $cgi($name)
				}
			}
		}

# puts [array names controlArray]
# puts --[array get attributeTable]--

		StoreArray controlArray $homePath/col/$thisRepository/auxdoc/controlArray.tcl w list array 1
		
		puts "<HTML><HEAD>
<TITLE>Administrator Page</TITLE>
<link rel=\"stylesheet\" type=\"text/css\" href=\"http://$localSite/col/$languageRep2/doc/mirrorStandard.css\">
<link rel=\"stylesheet\" type=\"text/css\" href=\"http://$localSite/col/$submissionFormLanguageRep/doc/mirrorStandard.css\">
</HEAD><BODY>"

# Source displayControl.tcl
		set enableOutput 1
		eval $sourceDisplayControl	;# set displayTable, attributeTable and boxTable, needed in ReturnAttributeValue called in CompileSearchList
# Source displayControl.tcl - end

		ConditionalSet valueList cgi(itemstobeupdated) {}	;# green box

		foreach index [array names controlArray] {
			set $index $controlArray($index)	;# set attributeTable
		}

# Update the items to be updated
		if ![string equal {} $valueList] {
			puts {<P ALIGN=CENTER><I>Update field value</I></P>}
			set i 0
			foreach value $valueList {
# value example:
## Acta_Astronautica {{y 20[01]* and index 0} and {journal, [Aa][A-Ha-h]*} and { journal Acta_Astronautica }} {{banon-pc3 800}}
# _Acta_Astronautica {{y 20[01]* and index 0} and {journal, _[Aa][A-Ha-h]*} and { journal _Acta_Astronautica }} {{banon-pc3 800}}
				foreach {inputFieldValue searchExpression itemSiteList} $value {break}
				puts <BR>[list $mappingDomainName $inputFieldValue]<BR>
				regsub {^_} $inputFieldValue {} inputFieldValue3	;# _Acta -> Acta - added by GJFB in 2014-07-07 (now item begins with _)
				foreach site $itemSiteList {
					puts <BR>[list server address: $site]<BR>
					set command [list list CheckPassword administrator $cgi(codedpassword1)]
					set flag [MultipleExecute [list $site] $command]
					if {[string equal {} $flag] || $flag} {continue}	;# wrong password
		 
					Execute $site [list WaitQueue2 Script {} $cgi(codedpassword1)] 0	;# not async
				
					regsub {^_} $item {} item3	;# _Acta -> Acta - added by GJFB in 2014-07-07 (now item begins with _)
#					set searchList [CompileSearchList $attributeList $year $mappingDomainName $inputFieldValue]
					set searchList [CompileSearchList $attributeList $year $mappingDomainName $inputFieldValue3]	;# added by GJFB in 2014-07-07
#					set query "$searchExpression and year $year and {[join $searchList { or }]}"	;# commented by GJFB in 2013-02-18
					set query "$searchExpression and {[join $searchList { or }]}"	;# added by GJFB in 2013-02-18 to let update records from any years - GJFB in 2014-07-01 says: this is no more true since searchExpression now contains the year (see enAdministratorPage.html)
# puts $query<BR>
## Acta_Astronautica {{y 20[01]* and index 0} and {journal, [Aa][A-Ha-h]*} and { journal Acta_Astronautica }} {{banon-pc3 800}}
# _Acta_Astronautica {{y 20[01]* and index 0} and {journal, _[Aa][A-Ha-h]*} and { journal _Acta_Astronautica }} {{banon-pc3 800}}
# puts --[FindMetadataRepositories $query 0 [list $site] $cgi(codedpassword1) yes yes]--
# >>> may return an error message
if 0 {
# old code - slower
					foreach item [FindMetadataRepositories $query 0 [list $site] $cgi(codedpassword1) yes yes] {
# puts $item
						set language2 $language
						
						set command [list list GetFieldValue2 $item repository]
						set repository [MultipleExecute [list $site] $command]
						set command [list list GetFieldValue2 $item metadatarepository]
						set metadatarepository [MultipleExecute [list $site] $command]
						set command [list list GetFieldValue2 $item readpermission]
						set readpermission [MultipleExecute [list $site] $command]
						set command [list list GetFieldValue2 $item language]
						set language [MultipleExecute [list $site] $command]
	
# Update @metadata.refer
						foreach attributeName $attributeList {
#							set attributeName [Execute $site [list ReturnReferModel $referenceType $referAttribute]]	;# dissimination
#							set newFieldValue [ReturnAttributeValue year=$year $mappingDomainName $attributeName $inputFieldValue]
							set newFieldValue [ReturnAttributeValue year=$year $mappingDomainName $attributeName $inputFieldValue3]	;# added by GJFB in 2014-07-07
							if [string equal {readpermission} $attributeName] {
								set readPermission $newFieldValue
								set languageFieldValue $language
							} elseif {[string equal {language} $attributeName]} {
								set readPermission $readpermission
								set languageFieldValue $newFieldValue
							} else {
# update other attribute
# puts $newFieldValue<BR>
#								set command [list list UpdateReferMetadata2 $metadatarepository [list [list $attributeName $newFieldValue]] $userName $password1]
#								MultipleExecute [list $site] $command
								Execute $site [list UpdateReferMetadata $metadatarepository [list [list $attributeName $newFieldValue]] $userName $password1]	;# updates @metadata.refer
								set readPermission $readpermission
								set languageFieldValue $language
							}
						}
						incr i
						puts [list $i $repository]
	
						set command [list UpdateRepMetadataRep \
						$repository $metadatarepository $userName $password1 preserve 0 \
						1 {} 1 $readPermission $userName {} \
						disable {} \
						{} {} 0 \
						$languageFieldValue]
# puts $command
#						set startApacheServer [MultipleExecute [list $site] $command]	;# must use UpdateRepMetadataRep2
						set startApacheServer [Execute $site $command]
# set startApacheServer 0
						if {![string equal 0 $startApacheServer] && \
							![string equal 1 $startApacheServer]} {
							puts {Script: error while executing UpdateRepMetadataRep}
							puts <BR>
							puts --$startApacheServer--
							set command [list list LeaveQueue [pid]]
							MultipleExecute [list $site] $command
							return
						}
# Update @metadata.refer - end
						set language $language2
						puts OK<BR>
					}
} else {
# new code - faster
					set metadataList {}	;# for add
					set metadata2List {}	;# for remove
					set repositoryList {}
					set rangeList {}
					foreach attribute $attributeList {
						if [string equal {secondarytype} $attribute] {
							lappend rangeList {PRE PI PN}
						} else {
							lappend rangeList {}	;# don't modifify new value - see ChangeFieldValue
						}
					}
# example of rangeList:
# set rangeList {{} {} {PRE PI PN}}	;# dissemination issn secondarytype
					foreach item [FindMetadataRepositories $query 0 [list $site] $cgi(codedpassword1) yes yes] {
# puts $item
						puts "<!-- [string repeat a 4096] -->"	;# to have the line displayed at once
						SetFieldValue $site $item "repository metadatarepository metadatalastupdate $attributeList"
						incr i
						if [string equal {} $repository] {
							puts "$i $item is just a bibliographic data base item or the connection with the server could not be established<BR>"
							continue
						}
						puts [list $i $repository]
						if [Execute $site [list GetDocumentState $repository]] {
# the document is the original								
#							set fieldNameList $attributeList
							set oldFieldValueList {}
							set newFieldValueList {}
							foreach attributeName $attributeList {
								lappend oldFieldValueList [set $attributeName]
#								lappend newFieldValueList [ReturnAttributeValue year=$year $mappingDomainName $attributeName $inputFieldValue]
								lappend newFieldValueList [ReturnAttributeValue year=$year $mappingDomainName $attributeName $inputFieldValue3]	;# added by GJFB in 2014-07-07
							}
							
#							ChangeFieldValue $site $metadatarepository $metadatalastupdate $fieldNameList $oldFieldValueList $newFieldValueList $userName $password1
							ChangeFieldValue $site $metadatarepository $metadatalastupdate $attributeList $oldFieldValueList $newFieldValueList $rangeList $userName $password1
							
							lappend repositoryList $repository $metadatarepository
							
							puts OK<BR>
						} else {
# the document is not the original
							puts {(the repository doesn't contain the original document)<BR>}
							continue
						}
					}
if 0 {
# commented by GJFB in 2020-08-18
					Execute $site [list RemoveMetadata $metadata2List]
					Execute $site [list AddMetadata $metadataList]
} else {
					Execute $site [list UpdateMetadata $metadata2List $metadataList]	;# added by GJFB in 2020-08-18 - uses metadata2List and metadataList
}
					Execute $site [list UpdateRepositoryListForPost $repositoryList]
}
					Execute $site [list LeaveQueue Script] 0	;# not async
				}
			}
			if $i {puts <BR>done} else {puts {<BR>nothing done}}
		}
# Update the items to be updated - end

# Create year=XXXX_mappingDomainName_attributeName.tcl
		CreateAnnualTable $thisRepository $attributeList $year $mappingDomainName
# Create year=XXXX_mappingDomainName_attributeName.tcl - end

		puts {<P ALIGN=CENTER>reloaded</P>}

		ConditionalSet updatedItemList cgi(updateditemlist) {}
		unset cgi
		source $homePath/col/$thisRepository/auxdoc/cgiArray.tcl
		set cgi(updateditemlist) $updatedItemList
		StoreArray cgi $homePath/col/$thisRepository/auxdoc/cgiArray.tcl w list array 1

		set returnButton "<BR>
<HR><TABLE ALIGN=CENTER><TR>
<FORM METHOD=POST ACTION=\"http://$localSite/col/$thisRepository/doc/script.cgi\">
<TD ALIGN=LEFT>
<INPUT TYPE=\"submit\" VALUE=\"Return\" CLASS=\"submitButton\"></TD>"
		CreateHiddenInput returnButton
		append returnButton "\
</FORM>
</TR></TABLE>
"
		puts $returnButton
		puts {</BODY></HTML>}
		exit
	}

# SUBST
# puts [array get cgi]
	puts [subst $fileContent]

} m] {puts <PRE>$m</PRE>; if 0 {global errorInfo; puts <PRE>$errorInfo</PRE>}}
}

# Script - end
# ----------------------------------------------------------------------
# CompileSearchList
# used in the above Script only

proc CompileSearchList {attributeList year mappingDomainName inputFieldValue} {
	upvar displayTable displayTable
	upvar attributeTable attributeTable
	upvar boxTable boxTable
	
	set searchList {}
	foreach attributeName $attributeList {
# puts $attributeName
		set fieldValue [ReturnAttributeValue year=$year $mappingDomainName $attributeName $inputFieldValue]
# puts $fieldValue
# => WEBSCI; PORTALCAPES.
		set fieldValue2 {}	;# complementary set
# puts --[ReturnAttributeValue year=$year $mappingDomainName $attributeName $inputFieldValue 1]--
# => --WEBSCI PORTALCAPES SCIELO AGU MGA COMPENDEX--
		foreach item [ReturnAttributeValue year=$year $mappingDomainName $attributeName $inputFieldValue 1] {
			if {[lsearch -regexp $fieldValue ^$item] == -1} {lappend fieldValue2 $item}
		}
		foreach item $fieldValue {
			lappend searchList [concat not $attributeName, $item]	;# not issn, 0094-5765
		}
		foreach item $fieldValue2 {
			lappend searchList [concat $attributeName, $item]
		}
		if [string equal {issn} $attributeName] {
			set numberOfISSNs [llength $fieldValue]
			lappend searchList [concat not \#$attributeName, $numberOfISSNs]	;# not #issn, 1 - added by GJFB in 2011-11-06 to solve the problem of multiple issn change (changing from 2 to 1)
		}
			
	}
	return $searchList
}

# CompileSearchList - end
# ----------------------------------------------------------------------
# CreateFieldValueRangeArray
# same code in iconet.com.br/banon/2007/01.07.13.17 (unifying)
# examples:
# CreateFieldValueRangeArray journal, A a f
# Aa-Af	journal, [Aa][A-Fa-f]*
# CreateFieldValueRangeArray journal, A
# A		journal, [Aa]*
# CreateFieldValueRangeArray journal, {K M}
# K-M	journal, [K-Mk-m]*

proc CreateFieldValueRangeArray {fieldName letterList {first {}} {last {}}} {
	upvar accentTable accentTable
	upvar fieldValueRangeArray fieldValueRangeArray
	
	if {[llength $letterList] == 2} {
		foreach {firstLetter lastLetter} $letterList {break}
		set lowerFirstLetter [string tolower $firstLetter]
		set lowerLastLetter [string tolower $lastLetter]
#		set fieldValueRangeArray($firstLetter-$lastLetter) "$fieldName \[$firstLetter-$lastLetter$lowerFirstLetter-$lowerLastLetter\]*"	;# commented by GJFB in 2014-07-01
		set fieldValueRangeArray($firstLetter-$lastLetter) "$fieldName _\[$firstLetter-$lastLetter$lowerFirstLetter-$lowerLastLetter\]*"	;# added by GJFB in 2014-07-01 to select by the first letters of the whole name and not of each word of the name
	} else {
		set upperLetter $letterList
		set upperLetterAccent $accentTable($upperLetter)
		set lowerLetter [string tolower $upperLetter]
		set lowerLetterAccent $accentTable($lowerLetter)
		if {[string equal {} $first] && [string equal {} $last]} {
#			set fieldValueRangeArray($upperLetter) "$fieldName \[$upperLetterAccent$lowerLetterAccent\]*"	;# commented by GJFB in 2014-07-01
			set fieldValueRangeArray($upperLetter) "$fieldName _\[$upperLetterAccent$lowerLetterAccent\]*"	;# added by GJFB in 2014-07-01 to select by the first letters of the whole name and not of each word of the name
		} else {
			set upperFirstLetter [string toupper $first]
			set upperLastLetter [string toupper $last]
#			set fieldValueRangeArray($upperLetter$first-$upperLetter$last) "$fieldName \[$upperLetterAccent$lowerLetterAccent\]\[$upperFirstLetter-$upperLastLetter$first-$last\]*"	;# commented by GJFB in 2014-07-01
			set fieldValueRangeArray($upperLetter$first-$upperLetter$last) "$fieldName _\[$upperLetterAccent$lowerLetterAccent\]\[$upperFirstLetter-$upperLastLetter$first-$last\]*"	;# added by GJFB in 2014-07-01 to select by the first letters of the whole name and not of each word of the name
		}
	}
}

if 0 {
	if [info exists fieldValueRangeArray] {unset fieldValueRangeArray}
	CreateFieldValueRangeArray journal, A a f
	CreateFieldValueRangeArray journal, A
	CreateFieldValueRangeArray journal, {K M}
	array get fieldValueRangeArray
}

# CreateFieldValueRangeArray - end
# ----------------------------------------------------------------------
# CreateAnnualTable
# creates file year=XXXX_mappingDomainName_attributeName.tcl
# sourced in displayControl.tcl (at submission)

proc CreateAnnualTable {thisRepository attributeList year mappingDomainName} {
	global homePath
	
	upvar controlArray controlArray
	
	file mkdir $homePath/col/$thisRepository/doc/tmp	;# added by GJFB in 2013-02-09
	foreach attributeName $attributeList {
		if [info exists attributeTable] {unset attributeTable}
		foreach item [array names controlArray attributeTable(year=$year,$mappingDomainName,$attributeName,*)] {
			set $item $controlArray($item)
		}
#		StoreArray attributeTable $homePath/col/$thisRepository/auxdoc/year=${year}_${mappingDomainName}_$attributeName.tcl w list array 1	;# commented by GJFB in 2013-02-09 - now in doc/tmp
		StoreArray attributeTable $homePath/col/$thisRepository/doc/tmp/year=${year}_${mappingDomainName}_$attributeName.tcl w list array 1	{} 1	;# added by GJFB in 2013-02-09 in order to let this file be exposed to the web
	}
}

# CreateAnnualTable - end
# ----------------------------------------------------------------------
# </PRE>